<?php

/* gvHIDRA. Herramienta Integral de Desarrollo Rpido de Aplicaciones de la Generalitat Valenciana
*
* Copyright (C) 2006 Generalitat Valenciana.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
*
* For more information, contact:
*
*  Generalitat Valenciana
*  Conselleria d'Infraestructures i Transport
*  Av. Blasco Ibez, 50
*  46010 VALENCIA
*  SPAIN
*  +34 96386 24 83
*  gvhidra@gva.es
*  www.gvpontis.gva.es
*
*/

/**
 * Formulario para visualizar la informacin del debug
 */

// nos situamos a nivel del proyecto
chdir('..');

// inicializacin framework
include_once('igep/include_class.php');
IgepSession::session_start();
include_once ('igep/include_all.php');
$aux = new AppMainWindow();

$configuration = ConfigFramework::getConfig();
$custom = $configuration->getCustomDirName();

 //Inicializamos algunos valores
 if (isset($_REQUEST['db_fecha'])) {
	$valorFecha = $_REQUEST['db_fecha'];
	IgepComunicacion::transform_User2FW($valorFecha,TIPO_FECHAHORA);
 } else
	$valorFecha = new gvHidraTimestamp();

 //autoreload 
 if(isset($_REQUEST['autoreload'])) 
 	$valorAutoreload = 'checked';
 else
 	$valorAutoreload = '';
 	 
 //Comprobamos si ha pulsado alguno de los botones que indican tiempo
if (isset($_REQUEST['Refrescar']))
 switch ($_REQUEST['Refrescar']){
 	case 'Ayer':
 		$valorFecha = new gvHidraTimestamp('-1 day');
 		break;
 	case 'Hoy':
 		$valorFecha = new gvHidraTimestamp('today');
 		break;
 	case '-10m':
 		$valorFecha = new gvHidraTimestamp('-10 minutes');
 		break; 	
 	case '-5m':
 		$valorFecha = new gvHidraTimestamp('-5 minutes');
 		break;
 	case 'Ya!':	
 		$valorFecha = new gvHidraTimestamp('now');
 }

if (is_null($valorFecha))
	echo 'La fecha no es correcta';
 
 if(isset($_REQUEST['db_usuario']))
	$valorUsuario = strtoupper($_REQUEST['db_usuario']);
 else
	$valorUsuario = '';
 
 if(isset($_REQUEST['db_aplicacion']))
	$valorAplicacion = $_REQUEST['db_aplicacion'];
 else{
	$valorAplicacion = $configuration->getApplicationName();
 }
 
 if(isset($_REQUEST["db_tipo"]))
	$valorTipo = $_REQUEST["db_tipo"];
 else
	$valorTipo = 5; 
 
 //Comprobamos si tenemos que calcular la consulta
 $resultDatos = array(); 
 if ($valorAplicacion!='' and !is_null($valorFecha)){   
	$dsn_log = $configuration->getDSNLog();
	$resultDatos = array();
	if (empty($dsn_log)) {
		echo 'No existe el dsn para el Log';
	} else {
		//$dsn_log['username']='usu';
		$conexion = new IgepConexion($dsn_log);
		$db_pear = $conexion->getPEARConnection();
		if (PEAR::isError($db_pear)) {
			echo 'Error de conexin al debug: '.$db_pear->userinfo;
		} else {
			$fechabd = clone $valorFecha;
			$conexion->prepararOperacion($fechabd, TIPO_FECHAHORA);
			//si hay usuario
			$whereUsuario='';
			if($valorUsuario!='')
				$whereUsuario = "and usuario='$valorUsuario'";
			$select = "SELECT iderror,aplicacion,modulo,version,usuario as \"usuario\",fecha as \"fecha\",tipo as \"tipo\",mensaje as \"mensaje\"
						FROM tcmn_errlog WHERE aplicacion='$valorAplicacion' and fecha>'$fechabd' and tipo<=$valorTipo $whereUsuario
						ORDER BY iderror DESC";
			// quitamos el log del consultar para que no interfiera en la salida
			$log = $configuration->getLogStatus();
			$configuration->setLogStatus(LOG_ERRORS);
			$resultDatos = $conexion->consultar($select, array('DATATYPES'=>array('fecha'=>TIPO_FECHAHORA)));
			$configuration->setLogStatus($log);
			if ($resultDatos==-1) {
				$resultDatos = array();
				$err = $conexion->obj_errorConexion->getDescErrorDB();
				echo 'Error en consulta: '.$err[0];
			}
		}
	}
 }
 $htmlResult = '<html>';
 $htmlResult.= '<head>';
 $htmlResult.= '<title>';
 $htmlResult.= 'Debugger de gvHIDRA';
 $htmlResult.= '</title>'; 
 if (!empty($custom))
 	$htmlResult.= "<link rel='stylesheet' href='custom/$custom/css/aplicacion.css' type='text/css' />";
 $htmlResult.= '</head>'; 
 $htmlResult.= '<body onLoad="javascript:formulario=document.forms[\'Refrescar\'];if(\''.$valorAutoreload.'\'==\'checked\'){setTimeout(\'formulario.submit();\',4000);};">';
 //Para meter los parmetros de la consulta
 $htmlResult.= "<form name='Refrescar' id='Refrescar' method='post' action=''>"; 
 $htmlResult.= '<table border="1" width="98%" class="TABLA_DATOS">';
 $htmlResult.= '<tr>';
 $htmlResult.= '<td colspan="3" width="85%">';
 $htmlResult.= '<b>Criterios de filtrado</b>';
 $htmlResult.= '</td>';
 $htmlResult.= '<td width="20%">';
 $htmlResult.= '<input type="submit" name="Refrescar"/ value="Refrescar">';
 $htmlResult.= '&nbsp;&nbsp;Auto <input id="autoreload" name="autoreload" type="checkbox" '.$valorAutoreload.' value="checked">'; 
 
 $htmlResult.= '</td>';
 $htmlResult.= '</tr>';
 $htmlResult.= '<tr>';
 $htmlResult.= '<td width="17%">'; 
 $htmlResult.= '&nbsp;Usuario: <input type="text" name="db_usuario" id="db_usuario" value="'.$valorUsuario.'" style=\'padding:0px;\'  size=\'12\'/>';
 $htmlResult.= '</td>';
 $htmlResult.= '<td width="38%">';
 $htmlResult.= '&nbsp;Fecha: <input type="text" name="db_fecha" id="db_fecha" value="'.(is_null($valorFecha)? $_REQUEST['db_fecha']: $valorFecha->formatUser()).'" style=\'padding:0px;\'  size=\'15\'/>';
 $htmlResult.= '&nbsp; <input type="submit" name="Refrescar"/ value="Ayer">';
 $htmlResult.= '&nbsp;<input type="submit" name="Refrescar"/ value="Hoy">';
 $htmlResult.= '&nbsp;<input type="submit" name="Refrescar"/ value="-10m">';
 $htmlResult.= '&nbsp;<input type="submit" name="Refrescar"/ value="-5m">';
 $htmlResult.= '&nbsp;<input type="submit" name="Refrescar"/ value="Ya!">';
 $htmlResult.= '</td>';
 $htmlResult.= '<td width="15%">';
 $htmlResult.= '&nbsp; Tipo: <select name="db_tipo">';
 
 if($valorTipo==0) 
  $htmlResult.= '<option value="0" selected>PANIC</option>';
 else
  $htmlResult.= '<option value="0">PANIC</option>';
 if($valorTipo==1) 
  $htmlResult.= '<option value="1" selected>ERROR</option>';
 else
  $htmlResult.= '<option value="1">ERROR</option>';
 if($valorTipo==2) 
  $htmlResult.= '<option value="2" selected>WARNING</option>';
 else
  $htmlResult.= '<option value="2">WARNING</option>';
 if($valorTipo==3)
  $htmlResult.= '<option value="3" selected>NOTICE</option>';
 else
  $htmlResult.= '<option value="3">NOTICE</option>';
 if($valorTipo==4)
  $htmlResult.= '<option value="4" selected>DEBUG_USER</option>';
 else
  $htmlResult.= '<option value="4">DEBUG_USER</option>';
 if($valorTipo==5)
  $htmlResult.= '<option value="5" selected>DEBUG_IGEP</option>';
 else
  $htmlResult.= '<option value="5">DEBUG_IGEP</option>';
 $htmlResult.= '</select>';
 $htmlResult.= '</td>'; 
 $htmlResult.= '<td>';
 $htmlResult.= '&nbsp; Aplicacin: <input type="text" name="db_aplicacion" id="db_aplicacion" value="'.$valorAplicacion.'" style=\'padding:0px;\'  size=\'12\'/>'; 
 $htmlResult.= '</td>';
 $htmlResult.= '</tr>';
 $htmlResult.= '</table>';
 $htmlResult.= '</form>';
 
 
 $htmlResult.= '<br>';
 $htmlResult.= '<table border="1" width="98%" class="TABLA_DATOS">';
 $htmlResult.= '<tr>';
 $htmlResult.= '<th class="formularios" border="1">';
 $htmlResult.= 'N';
 $htmlResult.= '</th>';
 $htmlResult.= '<th class="formularios" border="1" width="15%">';
 $htmlResult.= 'FECHA';
 $htmlResult.= '</th>';
 if(empty($valorUsuario)){
 	$htmlResult.= '<th class="formularios" border="1">';
 	$htmlResult.= 'USUARIO';
 	$htmlResult.= '</th>';
 } 
 $htmlResult.= '<th class="formularios" border="1">';
 $htmlResult.= 'TIPO';
 $htmlResult.= '</th>';
 $htmlResult.= '<th class="formularios" border="1">';
 $htmlResult.= 'MENSAJE';
 $htmlResult.= '</th>';
 $htmlResult.= '</tr>'; 
 //Iteramos para mostrar los resultados
 if(count($resultDatos)==0){
   $htmlResult.= '<tr>';
   if(empty($valorUsuario))
   	$htmlResult.= '<td colspan="5" align="center" border="1">';
   else
   	$htmlResult.= '<td colspan="4" align="center" border="1">';
   $htmlResult.= '<font color="#2C658F">NO HAY DATOS</font>';
   $htmlResult.= '</td>';
   $htmlResult.= '</tr>';
 }
 else{
   foreach($resultDatos as $indice=>$tupla){
     $htmlResult.= '<tr>'; 
     $htmlResult.= '<td border="1">';
     $htmlResult.= ($indice+1);
     $htmlResult.= '</td>';
     $htmlResult.= '<td border="1">';
     if (!is_null($tupla['fecha']))
     	$htmlResult.= $tupla['fecha']->formatUser();
     $htmlResult.= '</td>';
 	 if(empty($valorUsuario)){
	     $htmlResult.= '<td border="1">';
	     $htmlResult.= $tupla['usuario'];
	     $htmlResult.= '</td>';     
 	 }
     $htmlResult.= '<td border="1">';
     switch($tupla['tipo']){
      case 0:
        $htmlResult.= '<font color="#BB000C">PANIC</font>';  
        break;
      case 1:
        $htmlResult.= '<font color="#BB000C">ERROR</font>';
        break;
      case 2:
        $htmlResult.= '<font color="#FFAB3F">WARNING</font>';
        break;
      case 3:
        $htmlResult.= '<font color="#2C658F">NOTICE</font>';
        break;
      case 4:
        $htmlResult.= '<font color="#DFDFDF">DEBUG_USER</font>';
        break;
      case 5:
        $htmlResult.= '<font color="#7A8F2C">DEBUG_IGEP</font>';
        break;    
     }
     $htmlResult.= '</td>';
     $htmlResult.= '<td border="1">';
     $htmlResult.= $tupla['mensaje'];
     $htmlResult.= '</td>';
     $htmlResult.= '</tr>';
   }
 }
 $htmlResult.= '</table>';
 $htmlResult.= '</body>';
 $htmlResult.= '</html>';
 
 echo $htmlResult; 
?>
