<?php
/* gvHIDRA. Herramienta Integral de Desarrollo Rpido de Aplicaciones de la Generalitat Valenciana
*
* Copyright (C) 2006 Generalitat Valenciana.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
*
* For more information, contact:
*
*  Generalitat Valenciana
*  Conselleria d'Infraestructures i Transport
*  Av. Blasco Ibez, 50
*  46010 VALENCIA
*  SPAIN
*  +34 96386 24 83
*  gvhidra@gva.es
*  www.gvpontis.gva.es
*
*/
/**
 * IgepSalto. Clase que contiene la estructura de salto que necesita
 * IGEP. 
 * 
 * @author Toni Flix
 * @version $Id: IgepSalto.php,v 1.4.6.4 2012/01/16 10:02:55 afelixf Exp $
 * @package gvHIDRA 
 */
class IgepSalto
{
    var $str_idSalto;
    var $str_claseOrigen;
    var $str_claseDestino;
    var $str_accionDestino;
    var $str_accionVuelta;
    var $m_params = array();
  
    /**
    * Constructor del Objeto Salto    
    * @access public
    * @param String $str_claseOrigen Nombre de la clase origen del salto
    * @param String $str_idSalto Cadena identificadora delobjeto salto
    */
	function __construct($str_claseOrigen, $str_idSalto = '') 
	{
		$this->IgepSalto($str_claseOrigen, $str_idSalto);
			
	}
	
	
	/**
	* Constructor del Objeto Salto	
	* @access public
	* @param String $str_claseOrigen Nombre de la clase origen del salto
	* @param String $str_idSalto Cadena identificadora delobjeto salto
	*/
	function IgepSalto($str_claseOrigen,$str_idSalto = '') 
	{
		$this->str_claseOrigen = $str_claseOrigen;
		$this->_setId($str_idSalto);	
	}
  
	/**
	* Mtodo que fija el identificador de un salto
	* @params string  $str_idSalto  id del salto
	* @return string
	*/
	function _setId($str_idSalto){
		$this->str_idSalto = $str_idSalto;
	}

	/**
	* Mtodo que devuelve el identificador de un salto
	* @access public
	* @return string
	*/  
	function getId(){
		return $this->str_idSalto;
	}  
  
	function setClase($str_claseDestino){
		$this->str_claseDestino = $str_claseDestino;
	}

	/**
	* Mtodo que establece el nombre de la clase destino del salto
	* @access public
	* @param String $str_nameTargetClass Nombre de la clase destino del salto
	*/  
	function setNameTargetClass($str_nameTargetClass){
		$this->str_claseDestino = $str_nameTargetClass;
	}
	
	function getClaseDestino(){
		return $this->str_claseDestino;
	}

	/**
	* Mtodo que devuelve el nombre de la clase origen
	* @access public
	* @return string
	*/  
	function getNameSourceClass()
	{
		return $this->str_claseOrigen;
	}
	
	function setAccion($str_accionDestino){
		$this->str_accionDestino = $str_accionDestino;
	}

	function setAccionRetorno($str_accionVuelta){
		$this->str_accionVuelta = $str_accionVuelta;
	}


	function getDestinoIda(){
		return 'phrame.php?action='.$this->str_claseDestino.'__'.$this->str_accionDestino; 
	}
  
	function getDestinoVuelta(){
		return 'phrame.php?action='.$this->str_claseOrigen.'__'.$this->str_accionVuelta; 
	}


	function setParam($indice,$valor){
		$this->m_params[$indice] = $valor; 
	}

	function getParam($indice){
		return $this->m_params[$indice]; 
	}
  
	function setParams($params){
		if(is_array($params))
			$this->m_params = $params;
	}

	function getParams(){
		return $this->m_params; 
	}  
}//Fin class IgepSalto
?>
