<?php
require_once 'PHPUnit/Framework.php';

include_once('igep/smarty/plugins/function.CWCampoTexto.php');

/**
 * Test class for global functions
 * Generated by PHPUnit on 2007-10-22 at 13:24:06.
 */
class smartyCampoTextoTest extends PHPUnit_Framework_TestCase {
	private $s;

    /**
     * Sets up the fixture, for example, opens a network connection.
     * This method is called before a test is executed.
     *
     * @access protected
     */
    protected function setUp() {
    	//global $s;
    	$this->s = new Smarty_Phrame();

    }

    /**
     * Tears down the fixture, for example, closes a network connection.
     * This method is called after a test is executed.
     *
     * @access protected
     */
    protected function tearDown() {
    }

    /**
     * comprobar si existe la variable necesaria para aplicacion
     */
    public function testSinParametros() {
    	$expected = <<<HEREDOC
<span id='IGEPVisibleCWCampoTexto1' style='visibility:hidden;; ' ><label style='font-weight: bold; display:none; ' id='txt_CWCampoTexto1' for='CWCampoTexto1'>CWCampoTexto1:</label>
<input type='text' name='CWCampoTexto1' id='CWCampoTexto1' value=""   style='padding:0px; padding-right:0px; '     onFocus="javascript:if (this.readOnly != true) { this.select();;};" onDblClick="javascript:if (this.readOnly != true) { this.select();;};"  /></span>
HEREDOC;
        $this->assertEquals(smarty_function_CWCampoTexto(array(),$this->s),$expected,'sin parametros');
        $ss = new Smarty_Phrame();
        $this->assertEquals(smarty_function_CWCampoTexto(array('name'=>'nif'),$ss),$expected,'ignora name');
    }

    public function testConNombre() {
    	$expected = <<<HEREDOC
<span id='IGEPVisiblenif' style='visibility:hidden;; ' ><label style='font-weight: bold; display:none; ' id='txt_nif' for='nif'>Nif:</label>
<input type='text' name='nif' id='nif' value=""   style='padding:0px; padding-right:0px; '     onFocus="javascript:if (this.readOnly != true) { this.select();;};" onDblClick="javascript:if (this.readOnly != true) { this.select();;};"  /></span>
HEREDOC;
        $this->assertEquals(smarty_function_CWCampoTexto(array('nombre'=>'nif'),$this->s),$expected,'con nombre');
    }

    public function testConId() {
    	$expected = <<<HEREDOC
<span id='IGEPVisiblenif' style='visibility:hidden;; ' ><label style='font-weight: bold; display:none; ' id='txt_nif' for='nif'>Nif:</label>
<input type='text' name='nif' id='nif' value=""   style='padding:0px; padding-right:0px; '     onFocus="javascript:if (this.readOnly != true) { this.select();;};" onDblClick="javascript:if (this.readOnly != true) { this.select();;};"  /></span>
HEREDOC;
        $this->assertEquals(smarty_function_CWCampoTexto(array('nombre'=>'nif', 'editable'=>0),$this->s),$expected,'con id');

    	$expected = <<<HEREDOC
<span id='IGEPVisiblenif' style='visibility:hidden;; ' ><label style='font-weight: bold; display:none; ' id='txt_nif' for='nif'>Nif:</label>
<input type='text' name='nif' id='nif' value="" tabindex='-1'  style='padding:0px; padding-right:0px; '     onFocus="javascript:if (this.readOnly != true) { this.select();;};" onDblClick="javascript:if (this.readOnly != true) { this.select();;};"  /></span>
HEREDOC;
      $this->assertEquals(smarty_function_CWCampoTexto(array('nombre'=>'nif', 'editable'=>'false'),$this->s),$expected,'con nombre');

    	$expected = <<<HEREDOC
<span id='IGEPVisiblenif' style='visibility:hidden;; ' ><label style='font-weight: bold; display:none; ' id='txt_nif' for='nif'>Nif:</label>
<input type='text' name='nif' id='nif' value=""   style='padding:0px; padding-right:0px; '     onFocus="javascript:if (this.readOnly != true) { this.select();;};" onDblClick="javascript:if (this.readOnly != true) { this.select();;};"  /></span>
HEREDOC;
      $this->assertEquals(smarty_function_CWCampoTexto(array('nombre'=>'nif', 'editable'=>'true'),$this->s),$expected,'con nombre');
    }

	//TODO: muchas combinaciones por probar
}

?>
