<?php
/* gvHIDRA. Herramienta Integral de Desarrollo Rpido de Aplicaciones de la Generalitat Valenciana
*
* Copyright (C) 2006 Generalitat Valenciana.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
*
* For more information, contact:
*
*  Generalitat Valenciana
*  Conselleria d'Infraestructures i Transport
*  Av. Blasco Ibez, 50
*  46010 VALENCIA
*  SPAIN
*  +34 96386 24 83
*  gvhidra@gva.es
*  www.gvhidra.org
*
*/

/**
* Clase Manejadora <<$classname_detalle|capitalize>>
* 
* Creada con Genaro: generador de cdigo de gvHIDRA
* 
* @autor genaro
* @version 1.0
* @license http://opensource.org/licenses/gpl-2.0.php GNU Public License v.2
*/
class <<$classname_detalle|capitalize>> extends gvHidraForm_DB
{
	public function __construct() {

		//Recogemos dsn de conexion
		$conf = ConfigFramework::getConfig();
		$g_dsn = $conf->getDSN('<<$dsn>>');

		$nombreTablas= array('<<$tablename_detalle>>');
		parent::__construct($g_dsn, $nombreTablas);

		/************************ QUERYs ************************/
		//Consulta del modo de trabajo LIS
		$str_select = "SELECT <<section name=select loop=$fields_detalle>><<$fields_detalle[select]>> as \"<<if $foreignKey_detalle[select] eq "true">><<$fields_detalle[select]>><<else>>lis_<<$fields_detalle[select]>><</if>>\"<<if $smarty.section.select.last>><<else>>, <</if>><</section>> FROM <<$tablename_detalle>>";
		$this->setSelectForSearchQuery($str_select);

		//Where del modo de trabajo LIS
		//$str_where = "";
		//$this->setWhereForSearchQuery($str_where);

		//Order del modo de trabajo LIS
		$this->setOrderByForSearchQuery('1');


		//Consulta del modo de trabajo EDI
		//$str_select = "SELECT <<section name=select loop=$fields_detalle>><<$fields_detalle[select]>> as \"<<if $primaryKeyDetalle eq "true">>edi_id_detalle<<elseif $fields_detalle[select] eq "$foreignKeyDetalle">><<$tipoMaestro>>_id_maestro<<else>>edi_<<$fields_detalle[select]>><</if>>\"<<if $smarty.section.select.last>><<else>>, <</if>><</section>> FROM <<$tablename_detalle>>";		 
		$this->setSelectForEditQuery($str_select);

		//Where del modo de trabajo EDI		 
		//$str_where_editar = "";
		//$this->setWhereForEditQuery($str_where_editar);

		//Order del modo de trabajo EDI
		$this->setOrderByForEditQuery('1');

		/************************ END QUERYs ************************/


		/************************ MATCHINGs ************************/

		//Seccion de matching: asociacion campos TPL y campos BD
		
		//Modo de trabajo LIS
		<<section name=lis loop=$fields_detalle>>
		$this->addMatching("<<if $foreignKey_detalle[lis] eq "true">><<$fields_detalle[lis]>><<else>>lis_<<$fields_detalle[lis]>><</if>>","<<$fields_detalle[lis]>>","<<$tablename_detalle>>");
		//$this->addMatching("<<if $primaryKey_detalle[matchings] eq "true">>edi_id_detalle<<elseif $fields_detalle[matchings] eq "$foreignKeyDetalle">><<$tipoMaestro>>_id_maestro<<else>>edi_<<$fields_detalle[matchings]>><</if>>","<<$fields_detalle[matchings]>>","<<$tablename_detalle>>");
		<</section>>

		/************************ END MATCHINGs ************************/


		/************************ TYPEs ************************/

		//Fechas: gvHidraDate type
<<section name=fecha loop=$fields_detalle>>
		$fecha = new gvHidraDate(false);
<<if $types_detalle[fecha] eq "gvHidraDate">>
		$this->addFieldType('lis_<<$fields_detalle[fecha]>>',$fecha);
		//$this->addFieldType('edi_<<$fields_detalle[fecha]>>',$fecha);
		
<</if>>
<</section>>

		//Strings: gvHidraString type
<<section name=string loop=$fields_detalle>>
<<if $types_detalle[string] eq "gvHidraString">>
<<if $lengths_detalle[string] eq "">>
<<assign var='length' value='200'>>
<<else>>
<<assign var='length' value=$lengths_detalle[string]>>
<</if>>
		$string = new gvHidraString(false, <<$length>>);
		$this->addFieldType('lis_<<$fields_detalle[string]>>',$string);
		//$this->addFieldType('edi_<<$fields_detalle[string]>>',$string);
		
<</if>>
<</section>>
			
		//Integers: gvHidraInteger type
<<section name=int loop=$fields_detalle>>
<<if $types_detalle[int] eq "gvHidraInteger">>
		$int = new gvHidraInteger(false, <<$lengths_detalle[int]>>);
		$this->addFieldType('<<if $foreignKey_detalle[int] eq "true">><<$fields_detalle[int]>><<else>>lis_<<$fields_detalle[int]>><</if>>',$int);
		//$this->addFieldType('<<if $primaryKey_detalle[int] eq "true">>edi_id_detalle<<elseif $fields_detalle[int] eq "$foreignKeyDetalle">><<$tipoMaestro>>_id_maestro<<else>>edi_<<$fields_detalle[int]>><</if>>"',$int);
		
<</if>>
<</section>>

		//Floats: gvHidraFloat type
<<section name=float loop=$fields_detalle>>
<<if $types_detalle[float] eq "gvHidraFloat">>
<<assign var='partes' value=','|explode:$lengths_detalle[float]>>
		$float = new gvHidraFloat(false, <<$partes[0]>>);
		$float->setFloatLength(<<$partes[1]>>);
		$this->addFieldType('lis_<<$fields_detalle[float]>>',$float);
		//$this->addFieldType('edi_<<$fields_detalle[float]>>',$float);
		
<</if>>
<</section>>


		/************************ END TYPEs ************************/


		/************************ COMPONENTS ************************/
		
		//Declaracion de Listas y WindowSelection
		//La definicin debe estar en el AppMainWindow.php
		

		/************************ END COMPONENTS ************************/						
		
		//Asociamos con la clase maestro	
		$this->addPadre("<<$classname_maestro|capitalize>>");
		
	}//End construct

	/************************ CRUD METHODs ************************/

	/**
	* metodo preRecargar
	* 
	* @access public
	* @param object $objDatos
	* 
	* Incorpore aqui la logica para parametrizar la recarga. Por ejemplo:
	* - Incluir condiciones.
	* - Cancelar la accion. 
	*/	
	public function preRecargar($objDatos) {
		
		return 0;
	}

	/**
	* metodo postRecargar
	* 
	* @access public
	* @param object $objDatos
	* 
	* Incorpore aqui la logica para parametrizar los datos obtenidos. Por ejemplo:
	* - Completar la informacion obtenida.
	* - Cambiar el color de las filas dependiendo de su valor
	*/	
	public function postRecargar($objDatos) {
		
		return 0;
	}

	/**
	* metodo preEditar
	* 
	* @access public
	* @param object $objDatos
	* 
	* Incorpore aqui la logica para parametrizar la edicion. Por ejemplo:
	* - Incluir condiciones de filtrado.
	* - Cancelar la accion. 
	*/	
	public function preEditar($objDatos) {
		
		return 0;
	}

	/**
	* metodo postEditar
	* 
	* @access public
	* @param object $objDatos
	* 
	* Incorpore aqui la logica para parametrizar los datos obtenidos. Por ejemplo:
	* - Completar la informacion obtenida.
	*/	
	public function postEditar($objDatos) {
		
		return 0;
	}

	/**
	* metodo preInsertar
	* 
	* @access public
	* @param object $objDatos
	* 
	* Incorpore aqui la logica para parametrizar los datos a insertar. Por ejemplo:
	* - Calcular el valor de una secuencia.
	* - Cancelar la accin de insercion.
	*/		
	public function preInsertar($objDatos) {
		
		return 0;
	}
	
	/**
	* metodo postInsertar
	* 
	* @access public
	* @param object $objDatos
	* 
	* Incorpore aqui la logica para completar la operacion de insercion. Por ejemplo:
	* - Insertar en una segunda tabla.
	*/		
	public function postInsertar($objDatos) {
		
		return 0;
	}

	/**
	* metodo preModificar
	* 
	* @access public
	* @param object $objDatos
	* 
	* Incorpore aqui la logica para parametrizar la operacion de actualizacion. Por ejemplo:
	* - Calcular valores derivados.
	* - Cancelar la accin de actualizacion.
	*/
	public function preModificar($objDatos) {
		
		return 0;
	}
	
	/**
	* metodo postModificar
	* 
	* @access public
	* @param object $objDatos
	* 
	* Incorpore aqui la logica para completar la operacion de actulizacion. Por ejemplo:
	* - Actualizar en una segunda tabla
	*/	
	public function postModificar($objDatos) {
		
		return 0;
	}
	
	/**
	* metodo preBorrar
	* 
	* @access public
	* @param object $objDatos
	* 
	* Incorpore aqui la logica para parametrizar la operacion de borrado. Por ejemplo:
	* - Cancelar la accin de borrado.
	*/	
	public function preBorrar($objDatos) {
		
		return 0;
	}
	
	/**
	* metodo postBorrar
	* 
	* @access public
	* @param object $objDatos
	* 
	* Incorpore aqui la logica para completar la operacion de borrado. Por ejemplo:
	* - Borrar en una segunda tabla
	*/	
	public function postBorrar($objDatos) {
		
		return 0;
	}
	
	/**
	* metodo preNuevo
	* 
	* @access public
	* @param object $objDatos
	* 
	* Incorpore aqui los valores por defecto antes de insertar.
	*/	
	public function preNuevo($objDatos) {
		
		return 0;
	}
	
	/**
	* metodo preIniciarVentana
	* 
	* @access public
	* @param object $objDatos
	* 
	* Incorpore aqui la logica a ejecutar cuando entra en la ventana. Por ejemplo:
	* - Puede comprobar que el usuario tiene los permisos necesarios.
	*/	
	public function preIniciarVentana($objDatos) {
		
		return 0;
	}
	
	/************************ END CRUD METHODs ************************/
	
	/**
	* metodo accionesParticulares
	* 
	* @access public
	* @param string $str_accion
	* @param object $objDatos
	* 
	* Incorpore aqui la logica de sus acciones particulares. 
	* -En el parametro $str_accion aparece el id de la accion.
	* -En el parametro $objDatos esta la informacion de la peticion. Recuerde que debe fijar la operacion
	* con el metodo setOperacion.
	*/	
	public function accionesParticulares($str_accion, $objDatos) {
        
		throw new Exception('Se ha intentado ejecutar la accin '.$str_accion.' y no est programada.');        
    }
	
}//End <<$classname|capitalize>>

?>